Sehat_COVID-19/urls.py
from django.contrib import admin
from django.urls import include, path
from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('main.urls')),
    path('hospital/', include('hospital.urls')),
    path('datars/', include('datars.urls')),
    path('pasiennonrawat/', include('pasien_nonrawat.urls')),
    path('pasienrawat/', include('pasien_rawat.urls')),
    path('', include('authentications.urls')),
    path('', include('django.contrib.auth.urls'))

] + static(settings.MEDIA_URL, document_root = settings.MEDIA_ROOT)

datars/urls.py
from django.urls import path
from . import views

app_name = "datars"

urlpatterns = [
    path('', views.datars, name = 'datars-index'),
    path('post', views.post_datars, name='post'),
    path('js/<str:provinsi>/', views.detailrs_js, name = "datars-detailrs_js"),
    path('<str:provinsi>/', views.detail_rs, name = "datars-detailrs")
]

main/urls.py
from django.urls import path

from . import views

app_name = 'main'

urlpatterns = [
    path('', views.home, name='main-home'),
    path('save',views.save),
    path('testiform', views.testiform, name='testiform'),
    path('testiform_acc', views.testiform_acc, name='testiform_acc')
    
]

pasien_rawat/urls.py
from django.contrib import admin
from django.urls import path
from .views import index, submit_form

app_name = 'pasien_rawat'

urlpatterns = [
    path('', index, name='pasien_rawat-index'),
    path('submitform', submit_form, name='pasien_rawat-submitform'),
]

pasien_rawat/models.py
from django.db import models
from datars.models import ModelRS

class PasienRawat(models.Model):
    nama = models.CharField(max_length = 60)
    nomor_telepon = models.CharField(max_length = 20)
    alamat = models.CharField(max_length = 500)
    nama_rumah_sakit = models.CharField(max_length = 60)
    dokumen_hasil_test = models.ImageField(upload_to='images', blank = False)
    base64_doc = models.TextField(null=True)
    rumah_sakit = models.ForeignKey(ModelRS, on_delete = models.CASCADE)

pasien_rawat/forms.py
from django import forms
from .models import PasienRawat

class PasienRawatForm(forms.ModelForm):
    class Meta:
        model = PasienRawat
        fields = ['nama', 'nomor_telepon', 'alamat', 'nama_rumah_sakit', 'dokumen_hasil_test']
        widgets = {
            'nama' : forms.TextInput(attrs = {'class': 'form-control'}),
            'nomor_telepon' : forms.TextInput(attrs = {'class': 'form-control'}),
            'alamat' : forms.TextInput(attrs = {'class': 'form-control'}),
            'nama_rumah_sakit' : forms.TextInput(attrs = {'class': 'form-control'}),
            'dokumen_hasil_test' : forms.FileInput(attrs = {'id' : 'file-input', 'class': 'form-control'}),
        }

pasien_rawat/views.py
from django.shortcuts import render
from django.http import HttpResponseRedirect, JsonResponse
from django.core import serializers
from datars.models import ModelRS
from .forms import PasienRawatForm
from django.contrib.auth.decorators import login_required
from authentications.decorators import allowed

# Create your views here.
@login_required(login_url='/login')
@allowed(roles=['Patient'])
def index(request):
    rs_yang_tersedia = ModelRS.objects.all()
    provinsi_yang_tersedia = []
    for rs in rs_yang_tersedia:
        if rs.provinsi not in provinsi_yang_tersedia:
            provinsi_yang_tersedia.append(rs.provinsi)
    user_data = {
        'nama' : request.user.first_name,
        'nomor_telepon' : "",
        'alamat' : "",
        'nama_rumah_sakit' : "",
        'dokumen_hasil_test' : None,
    }
    context = {
        'pasien_rawat_form' : PasienRawatForm(initial = user_data),
        'provinsi_yang_tersedia' : provinsi_yang_tersedia
    }
    return render(request, "pasien_rawat/index.html", context)

@login_required(login_url='/login')
@allowed(roles=['Patient'])
def submit_form(request):
    import base64
    ada_rumah_sakitnya = False
    
    if request.is_ajax and request.method == "POST":
        form = PasienRawatForm(request.POST, request.FILES)
        if form.is_valid():
            pasien_rawat = form.save(commit=False)
            with form.cleaned_data["dokumen_hasil_test"].open('rb') as file:
                pasien_rawat.base64_doc = "data:image/png;base64,{}".format(base64.b64encode(file.read()).decode())
                semua_rs = ModelRS.objects.all()
                for rs in semua_rs:
                    if rs.nama == request.POST["nama_rumah_sakit"]:
                        pasien_rawat.rumah_sakit = rs
                        pasien_rawat.save()
                        ada_rumah_sakitnya = True
                        break
            if ada_rumah_sakitnya:
                pasienRawat_serialized = serializers.serialize('json', [ pasien_rawat, ])
                return JsonResponse({"pasien_rawat" :   pasienRawat_serialized}, status = 200)
            else:
                return JsonResponse({"error" : form.errors}, status = 400)
        else:
            return JsonResponse({"error" : form.errors}, status = 400)
    return HttpResponseRedirect('/pasienrawat/')

pasien_rawat/templates/pasien_rawat/index.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
    <link rel="stylesheet" type="text/css" href="{% static 'pasien_rawat/style.css' %}" />
    <title>Daftar Pasien Rawat</title>
{% endblock meta %}

{% block content %}
<div class = "js-pasien-rawat-template d-flex flex-column justify-content-center align-items-center">
    <p id = "title" class = "montserrat-regular large-font margin-top-4">Data Diri Pasien</p>
    <form class = "js-pasien-rawat-form full-size padding-4" action = "{% url 'pasien_rawat:pasien_rawat-submitform' %}" enctype="multipart/form-data">
        {% csrf_token %}
        <div class = "d-flex flex-column">
            <p class = "montserrat-regular medium-font">Nama</p>
            {{ pasien_rawat_form.nama }}
        </div>
        <div class = "d-flex flex-column margin-top-2">
            <p class = "montserrat-regular medium-font">No Telepon / HP</p>
            {{ pasien_rawat_form.nomor_telepon }}
        </div>
        <div class = "d-flex flex-column margin-top-2">
            <p class = "montserrat-regular medium-font">Alamat</p>
            {{ pasien_rawat_form.alamat }}
        </div>
        <div class = "d-flex flex-column margin-top-2">
            <p class = "montserrat-regular medium-font">RS</p>
            {{ pasien_rawat_form.nama_rumah_sakit }}
        </div>
        <div class = "d-flex flex-row margin-top-4">
            <p class = "montserrat-regular medium-font">Dokumen hasil test</p>
            <div class = "js-upload-button-div image-upload margin-left-4" style = "width: fit-content">
                {{ pasien_rawat_form.dokumen_hasil_test }}
                <img class = "js-upload-button full-size" src="/static/pasien_rawat/svg/upload.svg" alt = "upload">
            </div>
        </div>
        <div id = "button" class = "d-flex justify-content-center align-items-center" style = "width: fit-content;">
            <input class = "js-submit-button full-size" style = "width: max-content" type="image" src="/static/pasien_rawat/svg/submit.svg" alt="Submit"/>
        </div>
    </form>
    {% if provinsi_yang_tersedia %}
    <div class = "d-flex flex-column full-size padding-4 margin-top-4">
        <div id = "grey" class = "color-0 padding-half">
            <div class = "color-2">
                <p class = "montserrat-medium medium-font padding-1 margin-left-2">Rumah sakit yang tersedia</p>
            </div>
            {% for provinsi in provinsi_yang_tersedia %}
            <div class = "color-1">
                <a href="{% url 'datars:datars-detailrs' provinsi %}">
                    <p class = "montserrat-regular small-font padding-2 margin-left-1">{{ provinsi }}</p>
                </a>
            </div>
            {% endfor %}
        </div>
    </div>
    {% endif %}
</div>
{% endblock content %}

{% block javascript %}
    <script src = "{% static 'pasien_rawat/index.js' %}"></script>
{% endblock javascript %}